#!usr/bin/perl

my %counter;
my %piston;
my %battery;
my %spiston;
my %abpres;
my %data;
my %temp;
my $lkey;
my $cmax;

my @store;

my $dline;
my $tline;
my $msgid;

my $latitude;
my $longitude;
my $argos;

my $smin;
my $smax;
my $tmin;
my $tmax;
my $pmin;
my $pmax;

my $pressure;
my $temperat;
my $salinity;

my @temptdata;
my @tempsdata;

open OUT, ">summary.txt" || die "Can't open summary.txt";
print OUT "Position Information Summary\n\n";
print "Position Information Summary\n\n";

while (<>) {

  if (m#^\.$#) {
    last;
  }

  if (m#\d\d\d\d\d (\d\d\d\d\d)  \d\d \d\d \w(.*)#) {
    $argos = $1;
    $tline = $2;
    if ($tline =~ m#\s*(\d) (\d\d\d\d-\d\d-\d\d \d\d:\d\d:\d\d)\s*(\d+\.\d+)\s*(\d+\.\d+)\s*(\d+\.\d+)\s*(\d+)#) {
      print OUT $2 . " | " . $3 . " | " . $4 . " | " . $1 . "\n";
      print $2 . " | " . $3 . " | " . $4 . " | " . $1 . "\n";
      $latitude = $3;
      $longitude = $4;
    }
    next;
  }
  
  if (m#\s*\d\d\d\d-\d\d-\d\d \d\d:\d\d:\d\d\s*\d(.*)#) {
    $1 =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline = $1 . $2 . $3 . $4;
    $msgid = hex $2;
    ++$counter{$msgid};
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    if ($msgid == 1) {
      $piston{$counter{$msgid}} = hex $1;
      $battery{$counter{$msgid}} = hex $4;
    }
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    if ($msgid == 1) {
      $spiston{$counter{$msgid}} = hex $2;
      $abpres{$counter{$msgid}} = hex $3;
    }
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3 . $4;
    $tline = <>;
    $tline =~ m#\s*(\w\w)\s*(\w\w)\s*(\w\w)#;
    $dline .= $1 . $2 . $3;
    $data{$msgid} .= $dline . " ";
  }
}

# Print Out the Summarized Info
print OUT "\nMessage Counts\n\n";
print "\nMessage Counts\n\n";
foreach $key (sort {$a <=> $b} keys %counter) {
  print OUT "Message " . $key . ": " . $counter{$key} . "\n";
  print "Message " . $key . ": " . $counter{$key} . "\n";
}

print OUT "\nFloat Properties\n\n";
print "\nFloat Properties\n\n";

%temp = ();
foreach $key (keys %piston) {++$temp{$piston{$key}};}
$cmax = 0;
foreach $key (keys %temp) {if ($temp{$key} > $cmax) {$lkey = $key; $cmax = $temp{$key};}}
print OUT "Piston Position        : " . $lkey . "\n";
print "Piston Position        : " . $lkey . "\n";

%temp = ();
foreach $key (keys %spiston) {++$temp{$spiston{$key}};}
$cmax = 0;
foreach $key (keys %temp) {if ($temp{$key} > $cmax) {$lkey = $key; $cmax = $temp{$key};}}
print OUT "Surface Piston Position: " . $lkey . "\n";
print "Surface Piston Position: " . $lkey . "\n";

%temp = ();
foreach $key (keys %spiston) {++$temp{$abpres{$key}};}
$cmax = 0;
foreach $key (keys %temp) {if ($temp{$key} > $cmax) {$lkey = $key; $cmax = $temp{$key};}}
print OUT "Air Bladder Pressure   : " . $lkey . "\n";
print "Air Bladder Pressure   : " . $lkey . "\n";

%temp = ();
foreach $key (keys %spiston) {++$temp{$battery{$key}};}
$cmax = 0;
foreach $key (keys %temp) {if ($temp{$key} > $cmax) {$lkey = $key; $cmax = $temp{$key};}}
print OUT "Battery Voltage        : " . $lkey / 10 . "\n\n";
print "Battery Voltage        : " . $lkey / 10 . "\n\n";


print OUT "Service Argos ID\n\n";
print OUT $argos . "\n\n";
print "Service Argos ID\n\n";
print $argos . "\n\n";

close OUT;

#Produce an SVG plot of the profile.

foreach $key (keys %data) {
  @store = split " ", $data{$key};
  %temp = ();
  $cmax = 0;
  foreach $item (@store) {
    ++$temp{$item};  # use unless (exists $temp{$item}) ???
  }
  foreach $item (keys %temp) {
    if ($temp{$item} > $cmax) {$lkey = $item; $cmax = $temp{$item};}
  }
  $data{$key} = $lkey;
}

  $pmax = 0;
  $pmin = 0;
  $tmax = 0;
  $tmin = 99999;
  $smax = 0;
  $smin = 99999;

  open TEMPLATE, "template.svg" || die "Cannot open template";

  @store = ();
  foreach $key (sort {$a <=> $b} keys %data) {
    if ($key > 16) {next;}
    print $key . "\n";
    $dline = $data{$key};
    $dline =~ m#^\w\w(\w\w)#;
    if (hex $1 == 1) {
      $dline =~ m#\w{34}(\w\w\w\w)(\w\w\w\w)(\w\w\w\w)#;
      $tline = hex $3; $tline .= " "; $tline .= hex $1; $tline .= " "; $tline .= hex $2;
      push @store, $tline;
      $tline = '';
    } else {
      $dline =~ m#\w{4}(\w*)#;
      $tline .= $1;
    }
  }
  while ($tline =~ m#^(\w\w\w\w)(\w\w\w\w)(\w\w\w\w)(.*)#) {
    if (!(($3 == "FFFF") || ($1 == "FFFF") || ($2 == "FFFF"))) {
      $dline = hex $3; $dline .= " "; $dline .= hex $1; $dline .= " "; $dline .= hex $2;
      $tline = $4;
      push @store, $dline;
    } else { $tline = $4;}
  }

  @store = sort {$a <=> $b} @store;

  open DATAS, ">". $argos ."-data.txt" || die "Cannot open outgoing data file!";

  LINE:foreach $dline (@store) {

    if ($dline =~ m!(\d+) (\d+) (\d+)!) {
      $pressure = $1;
      $pressure /= 10;
      if ($pressure > 2000) {next LINE;}
      $temperat = $2;
      if ($temperat == 65535) {next LINE;}
      if ($temperat > 62535) {$temperat -= 65535;}
      $temperat /= 1000;

      $salinity = $3;
      if ($salinity == 65535) {next LINE;}
      $salinity /= 1000;

      if ($salinity> $smax) {
        $smax = $salinity;
      }
      if ($salinity < $smin) {
        $smin = $salinity;
      }
      if ($temperat > $tmax) {
        $tmax = $temperat;
      }
      if ($temperat < $tmin) {
        $tmin = $temperat;
      }
      if ($pressure > $pmax) {
        $pmax = $pressure;
      }

      push @temptdata, $temperat . " " . $pressure;
      push @tempsdata, $salinity . " " . $pressure;
      printf DATAS ("%-5.1f %-3.3f %-3.3f\n", $pressure, $temperat, $salinity);
    }
  }
  close DATAS;
  #Rounding maximums
  if ($tmax > 0) {
    $tmax =~ m!(\d*)\.(\d*)!;
    $digit = $1;
    $decimal = $2;
    if ($decimal > 0) {$digit ++;}
    $tmax = $digit;
  }
  if ($smax > 0) {
    $smax =~ m!(\d*)\.(\d*)!;
    $digit = $1;
    $decimal = $2;
    if ($decimal > 0) {$digit ++;}
    $smax = $digit;
  }
  if ($pmax > 0) {
    $pmax =~ m!(\d*)\.(\d*)!;
    $digit = $1;
    $decimal = $2;
    if ($decimal > 0) {$digit ++;}
    $pmax = $digit;
  }
  #Rounding minimums
  if ($tmin < 99999) {
    if ($tmin =~ m!(\d*)\.(\d*)!) {
      $digit = $1;
      $decimal = $2;
      if ($tmin < 0) { $sign = -1; } else { $sign = 1;}
      if ($sign < 0 && $decimal > 0) {$digit ++; $digit = "-" . $digit;}
      $tmin = $digit;
    }
  }
  if ($smin < 99999) {
    $smin =~ m!(\d*)\.(\d*)!;
    $digit = $1;
    $decimal = $2;
    if ($smin < 0) { $sign = -1; } else { $sign = 1;}
    if ($sign < 0 && $decimal > 0) {$digit ++; $digit = "-" . $digit;}
    $smin = $digit;
  }

  $trange = $tmax - $tmin;
  $srange = $smax - $smin;
  $prange = $pmax - $pmin;

  if ($trange == 0) {$trange = 0.01;}
  if ($srange == 0) {$srange = 0.01;}
  if ($prange == 0) {$prange = 0.01;}

  $ttrans = ($tmin * (675 / $trange) - 75) * -1;
  $strans = ($smin * (675 / $srange) - 75) * -1;
  $ptrans = ($pmin * (675 / $prange) - 75) * -1;

  foreach $line (@temptdata) {
    $line =~ m!(.*) (.*)!;
    $temperat = $1;
    $pressure = $2;

    $temperat *= (675 / $trange);
    $pressure *= (675 / $prange);

    $tdata = $tdata . $temperat . " " . $pressure . "\n";
  }
  foreach $line (@tempsdata) {
    $line =~ m!(.*) (.*)!;
    $salinity = $1;
    $pressure = $2;

    $salinity *= (675 / $srange);
    $pressure *= (675 / $prange);

    $sdata = $sdata . $salinity . " " . $pressure . "\n";
  }
    open OUTFILE, ">$argos.svg" || die "Cannot create output file.";
    while (!eof(TEMPLATE)){
      $tline = <TEMPLATE>;
      $tline =~ s!##ARGOSID##!$argos!;
      $tline =~ s!##LATITUDE##!$latitude!;
      $tline =~ s!##LONGITUDE##!$longitude!;
      $tline =~ s!##T1##!$tmin!;
      $tline =~ s!##T6##!$tmax!;
      $tline =~ s!##S1##!$smin!;
      $tline =~ s!##S6##!$smax!;
      $tline =~ s!##P1##!$pmin!;
      $tline =~ s!##P6##!$pmax!;
      $tline =~ s!##TDATA##!$tdata!;
      $tline =~ s!##SDATA##!$sdata!;
      $tline =~ s!##TTRANSLATE##!$ttrans!;
      $tline =~ s!##STRANSLATE##!$strans!;
      $tline =~ s!##PTRANSLATE##!$ptrans!;

      print OUTFILE $tline;
    }
    close OUTFILE;
  close TEMPLATE;
